typedef enum tds_request_capability 
	{                   TDS_REQ_LANG =  1
	,                    TDS_REQ_RPC =  2
	,                    TDS_REQ_EVT =  3
	,                  TDS_REQ_MSTMT =  4
	,                    TDS_REQ_BCP =  5
	,                 TDS_REQ_CURSOR =  6
	,                   TDS_REQ_DYNF =  7
	,                    TDS_REQ_MSG =  8
	,                  TDS_REQ_PARAM =  9
	,              TDS_REQ_DATA_INT1 = 10
	,              TDS_REQ_DATA_INT2 = 11
	,              TDS_REQ_DATA_INT4 = 12
	,               TDS_REQ_DATA_BIT = 13
	,              TDS_REQ_DATA_CHAR = 14
	,             TDS_REQ_DATA_VCHAR = 15
	,               TDS_REQ_DATA_BIN = 16
	,              TDS_REQ_DATA_VBIN = 17
	,              TDS_REQ_DATA_MNY8 = 18
	,              TDS_REQ_DATA_MNY4 = 19
	,             TDS_REQ_DATA_DATE8 = 20
	,             TDS_REQ_DATA_DATE4 = 21
	,              TDS_REQ_DATA_FLT4 = 22
	,              TDS_REQ_DATA_FLT8 = 23
	,               TDS_REQ_DATA_NUM = 24
	,              TDS_REQ_DATA_TEXT = 25
	,             TDS_REQ_DATA_IMAGE = 26
	,               TDS_REQ_DATA_DEC = 27
	,             TDS_REQ_DATA_LCHAR = 28
	,              TDS_REQ_DATA_LBIN = 29
	,              TDS_REQ_DATA_INTN = 30
	,         TDS_REQ_DATA_DATETIMEN = 31
	,            TDS_REQ_DATA_MONEYN = 32
	,               TDS_REQ_CSR_PREV = 33
	,              TDS_REQ_CSR_FIRST = 34
	,               TDS_REQ_CSR_LAST = 35
	,                TDS_REQ_CSR_ABS = 36
	,                TDS_REQ_CSR_REL = 37
	,              TDS_REQ_CSR_MULTI = 38
	,                TDS_REQ_CON_OOB = 39
	,             TDS_REQ_CON_INBAND = 40
	,            TDS_REQ_CON_LOGICAL = 41
	,             TDS_REQ_PROTO_TEXT = 42
	,             TDS_REQ_PROTO_BULK = 43
	,                 TDS_REQ_URGEVT = 44
	,       TDS_REQ_DATA_SENSITIVITY = 45
	,          TDS_REQ_DATA_BOUNDARY = 46
	,          TDS_REQ_PROTO_DYNAMIC = 47
	,          TDS_REQ_PROTO_DYNPROC = 48
	,              TDS_REQ_DATA_FLTN = 49
	,              TDS_REQ_DATA_BITN = 50
	,              TDS_REQ_DATA_INT8 = 51
	,              TDS_REQ_DATA_VOID = 52
	,               TDS_REQ_DOL_BULK = 53
	,           TDS_REQ_OBJECT_JAVA1 = 54
	,            TDS_REQ_OBJECT_CHAR = 55
	,          TDS_REQ_OBJECT_BINARY = 57
	,      TDS_REQ_DATA_COLUMNSTATUS = 58
	,              TDS_REQ_WIDETABLE = 59
	,             TDS_REQ_DATA_UINT2 = 61
	,             TDS_REQ_DATA_UINT4 = 62
	,             TDS_REQ_DATA_UINT8 = 63
	,             TDS_REQ_DATA_UINTN = 64
	,           TDS_REQ_CUR_IMPLICIT = 65
	,             TDS_REQ_DATA_NLBIN = 66
	,            TDS_REQ_IMAGE_NCHAR = 67
	,          TDS_OBS_BLOB_NCHAR_16 = 68 /* obsolete */
	,           TDS_REQ_BLOB_NCHAR_8 = 69
	,        TDS_REQ_BLOB_NCHAR_SCSU = 70
	,              TDS_REQ_DATA_DATE = 71
	,              TDS_REQ_DATA_TIME = 72
	,          TDS_REQ_DATA_INTERVAL = 73
	,             TDS_REQ_CSR_SCROLL = 74
	,          TDS_REQ_CSR_SENSITIVE = 75
	,        TDS_REQ_CSR_INSENSITIVE = 76
	,      TDS_REQ_CSR_SEMISENSITIVE = 77
	,       TDS_REQ_CSR_KEYSETDRIVEN = 78
	,             TDS_REQ_SRVPKTSIZE = 79
	,           TDS_REQ_DATA_UNITEXT = 80
	,    TDS_REQ_CAP_CLUSTERFAILOVER = 81
	,             TDS_REQ_DATA_SINT1 = 82
	,             TDS_REQ_LARGEIDENT = 83
	,          TDS_REQ_BLOB_NCHAR_16 = 84
	,               TDS_REQ_DATA_XML = 85
	,               TDS_REQ_CURINFO3 = 86
	,                 TDS_REQ_DBRPC2 = 87
	,                TDS_REQ_MIGRATE = 89
	,       TDS_REQ_DATA_BIGDATETIME = 93
	,           TDS_REQ_DATA_BIGTIME = 94
	,                TDS_REQ_CAP_MAX = 94 /* repeats last enum */
	} TDS_REQUEST_CAPABILITY;

typedef enum tds_response_capability 
	{                  TDS_RES_NOMSG =  1
	,                  TDS_RES_NOEED =  2
	,                TDS_RES_NOPARAM =  3
	,            TDS_RES_DATA_NOINT1 =  4
	,            TDS_RES_DATA_NOINT2 =  5
	,            TDS_RES_DATA_NOINT4 =  6
	,             TDS_RES_DATA_NOBIT =  7
	,            TDS_RES_DATA_NOCHAR =  8
	,           TDS_RES_DATA_NOVCHAR =  9
	,             TDS_RES_DATA_NOBIN = 10
	,            TDS_RES_DATA_NOVBIN = 11
	,            TDS_RES_DATA_NOMNY8 = 12
	,            TDS_RES_DATA_NOMNY4 = 13
	,           TDS_RES_DATA_NODATE8 = 14
	,           TDS_RES_DATA_NODATE4 = 15
	,            TDS_RES_DATA_NOFLT4 = 16
	,            TDS_RES_DATA_NOFLT8 = 17
	,             TDS_RES_DATA_NONUM = 18
	,            TDS_RES_DATA_NOTEXT = 19
	,           TDS_RES_DATA_NOIMAGE = 20
	,             TDS_RES_DATA_NODEC = 21
	,           TDS_RES_DATA_NOLCHAR = 22
	,            TDS_RES_DATA_NOLBIN = 23
	,              TDS_RES_DATA_INTN = 24
	,       TDS_RES_DATA_NODATETIMEN = 25
	,          TDS_RES_DATA_NOMONEYN = 26
	,              TDS_RES_CON_NOOOB = 27
	,           TDS_RES_CON_NOINBAND = 28
	,           TDS_RES_PROTO_NOTEXT = 29
	,           TDS_RES_PROTO_NOBULK = 30
	,     TDS_RES_DATA_NOSENSITIVITY = 31
	,        TDS_RES_DATA_NOBOUNDARY = 32
	,             TDS_RES_NOTDSDEBUG = 33
	,          TDS_RES_NOSTRIPBLANKS = 34
	,            TDS_RES_DATA_NOINT8 = 35
	,         TDS_RES_OBJECT_NOJAVA1 = 36
	,          TDS_RES_OBJECT_NOCHAR = 37
	,    TDS_RES_DATA_NOCOLUMNSTATUS = 38
	,        TDS_RES_OBJECT_NOBINARY = 39
	,           TDS_RES_DATA_NOUINT2 = 41
	,           TDS_RES_DATA_NOUINT4 = 42
	,           TDS_RES_DATA_NOUINT8 = 43
	,           TDS_RES_DATA_NOUINTN = 44
	,          TDS_RES_NO_WIDETABLES = 45
	,           TDS_RES_DATA_NONLBIN = 46
	,          TDS_RES_IMAGE_NONCHAR = 47
	,        TDS_RES_BLOB_NONCHAR_16 = 48
	,         TDS_RES_BLOB_NONCHAR_8 = 49
	,      TDS_RES_BLOB_NONCHAR_SCSU = 50
	,            TDS_RES_DATA_NODATE = 51
	,            TDS_RES_DATA_NOTIME = 52
	,        TDS_RES_DATA_NOINTERVAL = 53
	,         TDS_RES_DATA_NOUNITEXT = 54
	,           TDS_RES_DATA_NOSINT1 = 55
	,          TDS_RES_NO_LARGEIDENT = 56
	,       TDS_RES_NO_BLOB_NCHAR_16 = 57
	,          TDS_RES_NO_SRVPKTSIZE = 58
	,             TDS_RES_DATA_NOXML = 59
	,    TDS_RES_NONINT_RETURN_VALUE = 60
	,              TDS_RES_NOXNLDATA = 61
	,           TDS_RES_SUPPRESS_FMT = 62
	,    TDS_RES_SUPPRESS_DONEINPROC = 63
	,          TDS_RES_FORCE_ROWFMT2 = 64
	,                TDS_RES_CAP_MAX = 64 /* repeats last enum */
	} TDS_RESPONSE_CAPABILITY;
